Index: proj/include/ent.h
===================================================================
--- proj/include/ent.h	(revision 350)
+++ proj/include/ent.h	(revision 351)
@@ -8,8 +8,7 @@
  * @{
  */
 
-#include "basic_sprite.h"
-#include "list.h"
+#include "libs.h"
 
 /**
  * @brief Set scale.
Index: proj/include/interrupts_func.h
===================================================================
--- proj/include/interrupts_func.h	(revision 350)
+++ proj/include/interrupts_func.h	(revision 351)
@@ -8,10 +8,7 @@
  * @{
  */
 
-#include "timer.h"
-#include "kbc.h"
-#include "keyboard.h"
-#include "mouse.h"
+#include "libs.h"
 
 /**
  * @brief Subscribes all drivers used (timer->keyboard->mouse)
Index: proj/include/proj.h
===================================================================
--- proj/include/proj.h	(revision 350)
+++ proj/include/proj.h	(revision 351)
@@ -1,7 +1,8 @@
 #ifndef PROJ_H_INCLUDED
 #define PROJ_H_INCLUDED
 
-#include "sprite.h"
+#include "libs.h"
+
 #include "ent.h"
 
 basic_sprite_t       *bsp_crosshair;
Index: proj/include/proj_func.h
===================================================================
--- proj/include/proj_func.h	(revision 350)
+++ proj/include/proj_func.h	(revision 351)
@@ -8,11 +8,10 @@
  * @{
  */
 
-#include "ent.h"
-#include "text.h"
+#include "libs.h"
 #include "proj_structures.h"
 
-#include <stdint.h>
+//#include <stdint.h>
 
 /**
  * @brief Cleans up all memory, unsubscribes interrupts.
Index: proj/libs/classes/include/classes.h
===================================================================
--- proj/libs/classes/include/classes.h	(revision 350)
+++ proj/libs/classes/include/classes.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    classes classes
+ * @ingroup libs
  * @brief Classes module
  *
  * Provides useful and general classes.
Index: proj/libs/graph/include/graph.h
===================================================================
--- proj/libs/graph/include/graph.h	(revision 350)
+++ proj/libs/graph/include/graph.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    graph   graph
+ * @ingroup libs
  * @brief Graph module.
  *
  * Provides functions, classes and methods for graphic drawing.
Index: proj/libs/kbc/include/kbc.h
===================================================================
--- proj/libs/kbc/include/kbc.h	(revision 350)
+++ proj/libs/kbc/include/kbc.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    kbc kbc
+ * @ingroup libs
  * @brief   KBC module.
  *
  * @{
Index: proj/libs/rtc/include/rtc.h
===================================================================
--- proj/libs/rtc/include/rtc.h	(revision 350)
+++ proj/libs/rtc/include/rtc.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    rtc rtc
+ * @ingroup libs
  * @brief RTC (Real-Time Clock) module.
  *
  * @{
Index: proj/libs/timer/include/timer.h
===================================================================
--- proj/libs/timer/include/timer.h	(revision 350)
+++ proj/libs/timer/include/timer.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    timer   timer
+ * @ingroup libs
  * @brief   Timer module.
  *
  * @{
Index: proj/libs/uart/include/uart.h
===================================================================
--- proj/libs/uart/include/uart.h	(revision 350)
+++ proj/libs/uart/include/uart.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup uart uart
+ * @ingroup libs
  * @brief UART module.
  *
  * @{
Index: proj/libs/utils/include/utils.h
===================================================================
--- proj/libs/utils/include/utils.h	(revision 350)
+++ proj/libs/utils/include/utils.h	(revision 351)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup utils utils
+ * @ingroup libs
  * @brief Utilities module.
  *
  * @{
Index: proj/libs/libs.h
===================================================================
--- proj/libs/libs.h	(nonexistent)
+++ proj/libs/libs.h	(revision 351)
@@ -0,0 +1,32 @@
+#ifndef LIBS_H_INCLUDED
+#define LIBS_H_INCLUDED
+
+/**
+ * @defgroup    libs    libs
+ * @brief   Libraries module.
+ *
+ * @{
+ */
+
+#include "classes/include/classes.h"
+#include "graph/include/graph.h"
+#include "graph/include/sprite.h"
+#include "graph/include/text.h"
+#include "graph/include/rectangle.h"
+#include "graph/include/menu.h"
+#include "kbc/include/kbc.h"
+#include "kbc/include/keyboard.h"
+#include "kbc/include/mouse.h"
+#include "rtc/include/rtc.h"
+#include "timer/include/timer.h"
+#include "uart/include/uart.h"
+#include "utils/include/utils.h"
+#include "utils/include/errors.h"
+#include "utils/include/fast_math.h"
+#include "utils/include/xpm_utils.h"
+
+/**
+ * @}
+ */
+
+#endif //LIBS_H_INCLUDED

Property changes on: proj/libs/libs.h
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/src/campaign.c
===================================================================
--- proj/src/campaign.c	(revision 350)
+++ proj/src/campaign.c	(revision 351)
@@ -8,9 +8,9 @@
 #include "proj_func.h"
 #include "ent.h"
 #include "interrupts_func.h"
-#include "graph.h"
-#include "hltp.h"
-#include "errors.h"
+
+#include "libs.h"
+
 #include <math.h>
 
 int (campaign)(void){
Index: proj/src/chat.c
===================================================================
--- proj/src/chat.c	(revision 350)
+++ proj/src/chat.c	(revision 351)
@@ -8,13 +8,12 @@
 #include "proj_func.h"
 #include "ent.h"
 #include "interrupts_func.h"
-#include "graph.h"
-#include "rectangle.h"
-#include "hltp.h"
+#include "libs.h"
 #include "makecode_map.h"
-#include "errors.h"
 #include <math.h>
 
+#include "hltp.h"
+
 #define CHAT_MAX_SIZE   75
 #define CHAT_MAX_NUM    19
 static text_t      *t_text[CHAT_MAX_NUM] = {NULL};
Index: proj/src/ent.c
===================================================================
--- proj/src/ent.c	(revision 350)
+++ proj/src/ent.c	(revision 351)
@@ -2,13 +2,7 @@
 
 #include "ent.h"
 
-#include "graph.h"
-#include "sprite.h"
-#include "utils.h"
-#include "rectangle.h"
-#include "text.h"
-#include "errors.h"
-#include "queue.h"
+#include "libs.h"
 #include <math.h>
 
 #define GREEN_HEALTH_COLOR      0x009900
Index: proj/src/makecode_map.c
===================================================================
--- proj/src/makecode_map.c	(revision 350)
+++ proj/src/makecode_map.c	(revision 351)
@@ -1,3 +1,5 @@
+#include <lcom/lcf.h>
+
 #include "makecode_map.h"
 
 static const char makecode_map[] = {ERROR_CODE, ERROR_CODE, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '\'', ERROR_CODE /*«*/, ERROR_CODE /*escape*/,
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 350)
+++ proj/src/proj.c	(revision 351)
@@ -1,23 +1,17 @@
 #include <lcom/lcf.h>
 #include <lcom/proj.h>
 #include <lcom/liblm.h>
+
+#include "proj.h"
+
 #include <math.h>
 
 #include "proj_macros.h"
 #include "proj_func.h"
 
-#include "graph.h"
-#include "menu.h"
-#include "rtc.h"
-#include "hltp.h"
 #include "interrupts_func.h"
 #include "makecode_map.h"
 
-#include "graph.h"
-
-#include "rectangle.h"
-#include "font.h"
-
 #include "crosshair.h"
 #include "shooter.h"
 #include "zombie.h"
@@ -26,12 +20,9 @@
 #include "bullet.h"
 #include "map1.h"
 
-#include "errors.h"
+#include "hltp.h"
 
-#include "list.h"
 
-#include "proj.h"
-
 int main(int argc, char* argv[]) {
 
     lcf_set_language("EN-US");
@@ -47,8 +38,6 @@
     return 0;
 }
 
-
-
 #include "singleplayer.h"
 static int (multiplayer)(void);
 #include "chat.h"
Index: proj/src/proj_func.c
===================================================================
--- proj/src/proj_func.c	(revision 350)
+++ proj/src/proj_func.c	(revision 351)
@@ -3,15 +3,9 @@
 #include "proj_func.h"
 
 #include "interrupts_func.h"
-#include "graph.h"
-#include "keyboard.h"
-#include "errors.h"
+#include "libs.h"
 #include "proj_macros.h"
-#include "utils.h"
 #include "ent.h"
-#include "fast_math.h"
-#include "rectangle.h"
-#include "font.h"
 
 #include <math.h>
 
Index: proj/src/singleplayer.c
===================================================================
--- proj/src/singleplayer.c	(revision 350)
+++ proj/src/singleplayer.c	(revision 351)
@@ -8,11 +8,9 @@
 #include "proj_func.h"
 #include "ent.h"
 #include "interrupts_func.h"
-#include "graph.h"
-#include "hltp.h"
-#include "errors.h"
-#include "menu.h"
 
+#include "libs.h"
+
 #include "campaign.h"
 #include "zombies.h"
 
Index: proj/src/zombies.c
===================================================================
--- proj/src/zombies.c	(revision 350)
+++ proj/src/zombies.c	(revision 351)
@@ -4,13 +4,12 @@
 
 #include "proj.h"
 
+#include "libs.h"
+
 #include "proj_macros.h"
 #include "proj_func.h"
 #include "ent.h"
 #include "interrupts_func.h"
-#include "graph.h"
-#include "hltp.h"
-#include "errors.h"
 #include <math.h>
 
 #define ZOMBIES_NUM             5
Index: proj/Doxyfile
===================================================================
--- proj/Doxyfile	(revision 350)
+++ proj/Doxyfile	(revision 351)
@@ -2455,7 +2455,7 @@
 # Minimum value: 0, maximum value: 1000, default value: 0.
 # This tag requires that the tag HAVE_DOT is set to YES.
 
-MAX_DOT_GRAPH_DEPTH    = 0
+MAX_DOT_GRAPH_DEPTH    = 50
 
 # Set the DOT_TRANSPARENT tag to YES to generate images with a transparent
 # background. This is disabled by default, because dot on Windows does not seem
@@ -4949,7 +4949,7 @@
 # Minimum value: 0, maximum value: 1000, default value: 0.
 # This tag requires that the tag HAVE_DOT is set to YES.
 
-MAX_DOT_GRAPH_DEPTH    = 0
+MAX_DOT_GRAPH_DEPTH    = 50
 
 # Set the DOT_TRANSPARENT tag to YES to generate images with a transparent
 # background. This is disabled by default, because dot on Windows does not seem
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 350)
+++ proj/Makefile	(revision 351)
@@ -10,7 +10,7 @@
 .PATH: ${.CURDIR}/libs/utils/src
 
 SRCS= list.c queue.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c fast_math.c xpm_utils.c rtc.c uart.c makecode_map.c menu.c proj_func.c rectangle.c font.c ent.c proj.c hltp.c zombies.c campaign.c singleplayer.c chat.c scoreboards.c
-IPATHS=-I./include -I./libs/graph/include -I./libs/kbc/include -I./libs/rtc/include -I./libs/timer/include -I./libs/uart/include -I./libs/classes/include -I./libs/utils/include -I./maps -I./media/xpm
+IPATHS=-I./include -I./libs -I./libs/graph/include -I./libs/kbc/include -I./libs/rtc/include -I./libs/timer/include -I./libs/uart/include -I./libs/classes/include -I./libs/utils/include -I./maps -I./media/xpm
 
 CPPFLAGS += -pedantic ${IPATHS} -D LCOM_MACRO -D __LCOM_OPTIMIZED__ -Wall -Wextra -Wshadow -Wunreachable-code #-Weverything -Wno-padded -Wno-unused-macros
 